I just did the most amazing c++ code, got to share.

## Div1 250: The one with buildings

You are given a list of integers (building heights). The maximum number of integers possible is 4000 and the maximum integer possible is 4000. For each `0 <= i <= n`, find the minimum number of steps so that the final sequence has `i` equal integers. Every step is to increment a single integer by 1 (building a new floor in a building).

I had some difficulties getting to the right approach. At first trying to do things like sweeps and dynamic programmings :/ . Turns out the trick is to solve: What is the minimum cost to have `y` buildings of height `x` ? For each `x`, calculate those costs for all `y`, updating the values in a total cost function that considers all possible heights.

The trick is that there are only `O(N)` relevant values of `x` (those equal to the heights), and that it is easy to find, for each `y` the minimum cost to have `y` buildings of height `x`. Just pick the `y` largest buildings of height greater than or equal to `x` and increment them. This gives us an `O(N^3)` algorithm, however, for each `y`, you can reuse the result of `y-1` (you know the cost of fixing `y-1` buildings, just add a single building and we know the result for `y`.

This is an `O(N^2)` algorithm:

int minimum(vector<int> heights) { int n = heights.size(); // sort non-increasingly by height: sort(heights.begin(), heights.end()); const int INF = 4000 * 4000; // cost[i] will have the cost to have i equal buildings vector<int> cost(n + 1, INF); cost[1] = 0; // for each height: for (int i = 0; i < n; i++) { int c = 0; // for each number of buildings i - j + 1: for (int j = i - 1; j >= 0; j--) { // the minimum cost to have i - j + 1 buildings of this height c += heights[i] - heights[j]; // remember the best cost[i - j + 1] = std::min( cost[i - j + 1], c); } } // the problem actually asks for the XOR of all values, but I suspect // this is because of limitations in the return value size. int res = 0; for (int i = 2; i <= n; i++) { res ^= cost[i]; } return res; }

## Div1 450: The one with implementation

Classical problem. You are given a graph (no loops, bidirectional, connected, weighted, some weights are zero). Return the total number of shortest paths between vertices `0` and `N-1` modulo 1000000007. Note that zero-weight edges might make the number of shortest paths infinite, return -1 in that case. At most 2000 vertices and at most 2000 edges.

Okay, the complicated path is when paths are infinite. This can only happen if there is at least one shortest path that visits an edge with weight 0. So we need a way to know, for each edge, if it can belong to a shortest path.

The way to check if an edge `(u,v)` can belong to an optimal path requires us to know: The weight of the edge, the minimum distance `D` between 0 and `N-1`, the minimum distance `d` between 0 and `u` and the minimum distance `r` between `N-1` and `v`. If `d + w + r = D`, then the edge can be used in a shortest path. If any 0-weight edge is one of those, return -1.

The rest is to count the number of paths. How about `f(x)` which returns the number of shortest paths towards `N-1` starting with `x`. `f(N-1) = 1`, there is only one shortest path there. For the other vertices `x`, you find every `y` such that `(x,y)` can belong to a shortest path. Then `f(x) = sum(f(y))` , easy, right? . Just evaluate the vertices in non-increasing order of distance to `N-1`, since none of the edges used will have weight 0, we can do this sorting.

I broke a record with this problem. I used 4 lambdas in total. And I even nested lambdas this time, which is so unusual in c++ :).

const int MOD = 1000000009; int count(int N, vector<int> A, vector<int> B, vector<int> C) { // make the graph easier to use: vector<vector<int>> g(N); vector<vector<int>> w(N); vector<int> degree(N); for (int i = 0; i < A.size(); i++) { degree[--A[i]]++; degree[--B[i]]++; } for (int i = 0; i < N; i++) { g[i].resize(degree[i]); w[i].resize(degree[i]); degree[i] = 0; } auto addEdge = [&](int u, int v, int weight) { g[u][degree[u]] = v; w[u][degree[u]++] = weight; }; for (int i = 0; i < A.size(); i++) { addEdge( A[i], B[i], C[i] ); addEdge( B[i], A[i], C[i] ); } //Dijkstra time! auto dijkstra = [&](int s, vector<int> &dist) { set<pair<int,int>> Q; const int INF = 2000000000; dist.resize(N, INF); for (int i = 0; i < N; i++) { Q.insert( {INF, i} ); } auto push = [&](int x, int d) { if (d < dist[x]) { Q.erase(Q.find( {dist[x],x})); dist[x] = d; Q.insert( {dist[x], x} ); } }; push(s, 0); while (! Q.empty()) { auto it = Q.begin(); int x = it->second; Q.erase(it); for (int i = 0; i < degree[x]; i++) { int v = g[x][i]; int we = w[x][i]; push(v, dist[x] + we); } } }; vector<int> dist, rdist; dijkstra(0, dist); dijkstra(N-1, rdist); // if any of the shortest paths visits an edge of weight 0, the result // is -1. It is possible to have 0s in the input and result diff to -1 for (int i = 0; i < A.size(); i++) { if (C[i] == 0) { int u = A[i], v = B[i]; for (int r = 0; r < 2; r++) { if (dist[u] + rdist[v] == dist[N-1]) { //critical return -1; } swap(u,v); } } } // And now the part in which we actually count the roads. vector<long> dp(N); vector<int> byRDist(N); for (int i = 0; i < N; i++) { byRDist[i] = i; } sort(byRDist.begin(), byRDist.end(), [&](int a, int b) { return rdist[a] < rdist[b]; }); for (int u: byRDist) { dp[u] = 0; if (u == N-1) { dp[u] = 1; } for (int i = 0; i < degree[u]; i++) { int v = g[u][i]; int we = w[u][i]; if ( (rdist[v] < rdist[u]) && (dist[u] + rdist[v] + we == dist[N-1]) ) { dp[u] += dp[v]; } } dp[u] %= MOD; } return dp[0]; }

## The rest

I was very slow, everybody else has a much better score. I hope many of them fail. I am confident in the correctness of my solutions and I don't suspect of any likely implementation bug. Typing this as the challenge phase begins.

During challenge phase: 8 minutes of challenge phase, and I doubt I'll score a successful challenge, there are some tough challengers in my room and they are very quick to find errors. There seem to be many ways to get 450 wrong.

## 2 comments :

Hi Vexorian. Could you please explain or provide a link about what you mean by using/nesting lambdas? Thanks!

Just using lambda expressions, new c++11 feature. But lambdas were in use by other languages for very long.

http://www.vexorian.com/2013/08/test-srm-2-revenge-of-c11.html

Post a Comment